<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Arvmaster;

/**
 * ArvmasterSearch represents the model behind the search form about `app\models\Arvmaster`.
 */
class ArvmasterSearch extends Arvmaster
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['arv_mstr_id', 'arv_mstr_qty', 'create_time', 'create_user', 'update_time', 'update_user', 'record_date'], 'integer'],
            [['arv_mstr_code', 'arv_mstr_name', 'arv_mstr_dose', 'status'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Arvmaster::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
			'sort'=>[
                'defaultOrder'=>['record_date'=> SORT_DESC],
            ],
        ]);
        if(empty($params))
            $params = Yii::$app->request->post();
        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'arv_mstr_id' => $this->arv_mstr_id,
            'arv_mstr_qty' => $this->arv_mstr_qty,
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
            'record_date' => $this->record_date,
        ]);

        $query->andFilterWhere(['like', 'arv_mstr_code', $this->arv_mstr_code])
            ->andFilterWhere(['like', 'arv_mstr_name', $this->arv_mstr_name])
            ->andFilterWhere(['like', 'arv_mstr_dose', $this->arv_mstr_dose])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}
